MODULE TestR3 EXPORTS Main;

IMPORT R3, R3x3, R3x3Extras, Wr, Thread, Fmt, CPUTime;
FROM Stdio IMPORT stderr;

PROCEDURE DoIt( ) =
  <* FATAL Wr.Failure, Thread.Alerted *>
  VAR iTime, fTime: LONGREAL;
  BEGIN
    iTime := CPUTime.Now();
    WITH
      s = R3x3Extras.Rotation(3.1415926d0/2.0d0, R3.T{0.0, 0.0, 1.0}),
      ax = R3.Dir(R3.T{1.0, 2.0, 3.0}),
      u = R3.Dir(R3.T{3.0, 2.0, 1.0}),
      r = R3x3Extras.Rotation(0.1d0, ax),
      rax = R3x3.MapRow(ax, r),
      ru = R3x3.MapRow(u, r)
    DO
      Wr.PutText(stderr, "Rot(+90, ZAxis):\n");
      R3x3.Print(stderr, s);
      Wr.PutText(stderr, "\n");
      
      Wr.PutText(stderr, "rotation matrix:\n");
      R3x3.Print(stderr, r);
      Wr.PutText(stderr, "\n");
      
      Wr.PutText(stderr, "axis = ");
      R3.Print(stderr, ax);
      R3.Print(stderr, rax);
      Wr.PutText(stderr, "\n");
      
      Wr.PutText(stderr, "u =    ");
      R3.Print(stderr, u);
      R3.Print(stderr, ru);
      Wr.PutText(stderr, "\n");
      FOR i := 0 TO 2 DO 
        FOR j := i TO 2 DO 
          Wr.PutText(stderr, Fmt.Pad(Fmt.Int(i), 2));
          Wr.PutText(stderr, Fmt.Pad(Fmt.Int(j), 2));
          Wr.PutText(stderr, Fmt.Pad(Fmt.LongReal(R3.Dot(r[i], r[j])), 20));
          Wr.PutText(stderr, "\n");
        END
      END;
    END;
    fTime := CPUTime.Now();
    WITH secs = (fTime - iTime) DO
      Wr.PutText(stderr, "CPU time = " & Fmt.LongReal(secs, Fmt.Style.Fix, 3) & "s\n")
    END;
    Wr.PutText(stderr, "Done.\n");
  END DoIt;

BEGIN
  DoIt();
END TestR3.
